

         {----------------------------------------------------}
         {      ViewLT  V 1.0   TURBO SUPPORT     }
         {      ணࠬ஢ Turbo Pascal  V 6.0      }
         {----------------------------------------------------}
         {  ᫥  :  09/08/1991             }
         {----------------------------------------------------}
         {  ।祭  ࠡ⪨ ⥪⮢ ⮪}
         {     ᬮ  ⬥⪨  ப ⥪      }
         {----------------------------------------------------}
         { (c) 1991,  ᫠                            }
         {----------------------------------------------------}

UNIT ViewBT;

{$IFDEF DEBUGVIEW}
      {$D+,L+,R+,S+}
{$ELSE}
      {$D-,L-,R-,S-}
{$ENDIF}

{$F+,O+,I-,V-,B-,A+}

INTERFACE

USES Crt, Dos, Fkey11, Def, TWindow, LcText, ViewT;

CONST
     MaxBlk = 1000;

TYPE
    ViewBlockText = OBJECT  ( ViewText )
                { 쥪 騩 ⬥  ப ⥪⮢
                  ᪠                     }

                BeginBlock : ARRAY [ 1..MaxBlk ] OF LONGINT;
                           {  ப 砫 ᮮ⢥ }
                           {          ⥪⮢            }

                EndBlock : ARRAY [ 1..MaxBlk ] OF LONGINT;
                           {  ப  ᮮ⢥ }
                           {          ⥪⮢            }

                ControlBlock : ARRAY [ 1..MaxBlk ] OF BYTE;
                           { ਧ ⬥祭  }

                ColorText : BYTE;
                              { 梥 ⥪ }

                ColorFon : BYTE;
                              { 梥 ᭮ 䮭 }

                ColorHelp : BYTE;
                              { 梥 䮭 ᪠ }

                ColorInsert : BYTE;
                              { 梥 뤥 ப }

                NumberHelpBlock : LONGINT;
                               {  ᯮ⥫쭮  }

                NumberEndBlock : LONGINT;
                               {  ᫥  }

                WindowBlock : BYTE;
                               { ⢮  ஫뢠   }

                CONSTRUCTOR Init ( WindPtr : TextWindowPtr;
                                   Stream : POINTER );
                          { 樠 쥪 }

                PROCEDURE MarkBlock; VIRTUAL;
                          { ન஢  }

                PROCEDURE SetColorText ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 ⥪   }

                PROCEDURE SetColorFon ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 䮭   }

                PROCEDURE SetColorHelp ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 䮭 ⨢ ப }

                PROCEDURE SetColorInsert ( Cl : BYTE ); VIRTUAL;
                          { ⠭ 梥 ᨬ 뤥 ப }

                PROCEDURE Show_Inf; VIRTUAL;
                          {   ⥪饥 ﭨ ଠ樨  }
                          {           ⨢஢           }

                PROCEDURE Control_Inf ( VAR ext_byte : LONGINT ); VIRTUAL;
                          { 楤 ࠢ ଠ樥  }
                          {        ⨢஢        }

                FUNCTION TestBlock ( num : LONGINT ) : BOOLEAN;
                         { ஢ઠ     稥 }
                         {            䫠 ⬥⪨            }

                FUNCTION SizeBlock ( Num : LONGINT ) : LONGINT;
                         { 뤠 ࠧ  / ⢮ ப / }

                PROCEDURE line_down; VIRTUAL;  { 㯯 楤       }
                PROCEDURE line_up;   VIRTUAL;  { ࠢ ⥪⮢ }
                PROCEDURE Insert;     VIRTUAL; { ଠ樥      }
                PROCEDURE TextEnd;    VIRTUAL;
                PROCEDURE TextHome;   VIRTUAL;
                PROCEDURE Window_Down; VIRTUAL;
                PROCEDURE Window_Up;   VIRTUAL;

                DESTRUCTOR Done;
                         { 樠 쥪 }

                DESTRUCTOR DoneWithStream;
                         { 樠 쥪   ⮪ }

                END; { object ViewBlockText }

{----------------------------------------------------------}

    
    ViewTehnicHelp = OBJECT ( ViewBlockText )

                PROCEDURE MarkBlock; VIRTUAL;
                          { ન஢  }

                PROCEDURE Control_Inf ( VAR ext_byte : LONGINT ); VIRTUAL;
                          { 楤 ࠢ ଠ樥  }
                          {        ⨢஢        }

                FUNCTION GetHelpNumber ( NumLine : LONGINT )
                                         : StandartString;
                          {   ᪠ }

                END; { object  ViewTehnicHelp }

IMPLEMENTATION

{----------------------------------------------------------}

PROCEDURE FatalError ( Line : STRING );

BEGIN
     WINDOW ( 1, 1, 80, 25 );
     TEXTBACKGROUND ( BLACK );
     TEXTCOLOR ( LIGHTGRAY );
     CLRSCR;
     WRITELN ( #07 );
     WRITELN ( '᪨ ᡮ  쥪 ViewBlockText' );
     WRITELN ( Line );
     WRITELN ( '믮 ணࠬ ४頥,'
              ,' 頩  ணࠬ' );
     HALT ( 1 )

END; { procedure FatalError }

{----------------------------------------------------------}

CONSTRUCTOR ViewBlockText.Init ( WindPtr :TextWindowPtr; Stream : POINTER );

           { 樠 쥪 }
VAR
   Index : WORD;

BEGIN
     ViewText.Init ( WindPtr, Stream );
     FOR Index := 1 TO MaxBlk DO
         ControlBlock [ Index ] := 0;
     MarkBlock;
     SetColorText ( BLUE );
     SetColorFon ( CYAN );
     SetColorHelp ( RED );
     SetColorInsert ( YELLOW );
     NumberHelpBlock := 1;
     WindowBlock := 7

END;  { constructor ViewBeginText.Init }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.MarkBlock;

          { ન஢  }
VAR
   SingFirst : BOOLEAN;
   Line : STRING;
   Size : BYTE;

BEGIN
     NumberEndBlock := 1;
     TextStream^.SetLineNumber ( 1 );
     SingFirst := FALSE;
     Size := 0;
     WHILE ( ( NOT TextStream^.EOFText ) AND ( NumberEndBlock <= MaxBlk ) ) DO
           BEGIN
                TextStream^.ReadLine ( Line );
                IF ( NOT SingFirst ) THEN
                   BEGIN
                        IF ( ( Line <> '' ) AND ( Line [ 1 ] = ' ' ) ) THEN
                           BEGIN
                                SingFirst := TRUE;
                                BeginBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 1;
                                Size := 0
                           END
                   END
                ELSE
                    BEGIN
                         INC ( Size );
                         IF ( ( ( Line <> '' ) AND ( Line [ 1 ] = ' ' ) ) OR
                            ( TextStream^.EOFText ) ) THEN
                            BEGIN
                                 EndBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 2;
                                 INC ( NumberEndBlock );
                                 BeginBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 1;
                                 Size := 0;
                                 IF ( TextStream^.EOFText ) THEN
                                     DEC ( EndBlock [ NumberEndBlock - 1 ] )
                            END
                         ELSE
                             IF ( Size >= 10 ) THEN
                                BEGIN
                                     SingFirst  := FALSE;
                                     EndBlock [ NumberEndBlock ] :=
                                               TextStream^.GetLineNumber - 1;
                                     INC ( NumberEndBlock );
                                     Size := 0
                                END
                    END
           END;
     DEC ( NumberEndBlock );
     IF ( NumberEndBlock = 0 ) THEN
        FatalError ( '㦥   ⮪ MarkBlock' );
     TextStream^.SetLineNumber ( 1 )

END; { procedure ViewBeginText.MarkBlock }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.Show_Inf;

          {   ⥪饥 ﭨ ଠ樨  }
          {           ⨢஢           }
VAR
   x, y : BYTE;
   Index : INTEGER;
   Stroka : STRING;
   Help : STRING;
   IndexX, EndX : BYTE;
   NumLine : LONGINT;
   NumBlock : LONGINT;
   First, Hlp : RecLinePtr;
   SzLines : LONGINT;

BEGIN
     First := NIL;
     Hlp := First;
     IF ( key_ramka ) THEN
        x := 1
     ELSE
         x := 0;
     stroka := '';
     FOR Index := 1 TO size_x DO
         stroka := CONCAT ( stroka, ' ' );
     IF ( Number < 1 ) THEN
        FatalError ( '⠭   < 1  Show_Inf' );
     TextStream^.SetLineNumber ( BeginBlock [ Number ] );
     NumLine := BeginBlock [ Number ];
     TextStream^.SaveState;
     SzLines := TextStream^.GetSize - NumLine;
     IF ( SzLines > Size_Y ) THEN
        SzLines := Size_Y;
     TextStream^.ReadLines ( SzLines, First );
     Hlp := First;
     NumBlock := Number;
     WindowPtr^.SetColorFon ( ColorFon );
     WindowPtr^.SetColorSymbol ( ColorText );
     FOR Index := 1 TO size_y DO
         BEGIN
              IF ( ( ControlBlock [ NumBlock ] <> 0 ) AND
                   ( NumLine <> 0 ) ) THEN
                  WindowPtr^.SetColorSymbol ( ColorInsert )
              ELSE
                  WindowPtr^.SetColorSymbol ( ColorText );
              IF ( NumBlock = NumberHelpBlock ) THEN
                  WindowPtr^.SetColorFon ( ColorHelp )
              ELSE
                  WindowPtr^.SetColorFon ( ColorFon );

              WindowPtr^.WPrint ( LO ( x + 1 ), LO ( Index + x ), stroka );
              IF ( Hlp <> NIL ) THEN
                 BEGIN
                      Help := Hlp^.Line;
                      Hlp := Hlp^.Next
                 END
              ELSE
                  Help := '';

              EndX := PointBeginX + Size_X - 1;
              IF ( EndX > LENGTH ( Help ) ) THEN
                 EndX := LENGTH ( Help );
              FOR IndexX := PointBeginX TO EndX DO
                  WindowPtr^.WChar ( LO ( X + IndexX - PointBeginX + 1),
                                     LO ( Index + x ), Help [ IndexX ] );

              IF ( NumLine <> 0 ) THEN
                 IF ( NumLine < EndBlock [ NumBlock ] ) THEN
                    INC ( NumLine )
                 ELSE
                     BEGIN
                          INC ( NumBlock );
                          NumLine := BeginBlock [ NumBlock ];
                          IF ( NumBlock > NumberEndBlock ) THEN
                             NumLine := 0
                     END
         END;
     TextStream^.RestoreState;
     WindowPtr^.PrintWindow;
     ClearListRecLine ( First );
     WindowPtr^.SetColorFon ( ColorFon );
     WindowPtr^.SetColorSymbol ( ColorText )

END; { procedure ViewBlockText.Show_Inf }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.Control_Inf ( VAR ext_byte : LONGINT );

         { 楤 ࠢ ଠ樥  }
         {        ⨢஢        }
VAR
   indx : WORD;
   ChCmd : CHAR;

BEGIN
     REPEAT
           show_inf;
           ChCmd := GetKeyBoard;
           IF ( GetSingKey ) THEN
              BEGIN
                   ChCmd := GetKeyBoard;
                   CASE ChCmd OF
                        arrow_down : line_down;
                        arrow_up   : line_up;
                        arrow_Left : CharLeft;
                        arrow_Right: CharRight;
                        page_down  : window_down;
                        page_up    : window_up;
                        key_ins    : Insert;
                        key_end    : TextEnd;
                        key_home   : TextHome
                   ELSE
                       run_for_key ( ChCmd )
                   END
              END
     UNTIL ( ChCmd IN [ #27, #$0D, #0 ] );
     IF ( ( ChCmd = #$0D ) OR ( ChCmd = #0 ) ) THEN
         ext_byte := NumberHelpBlock
     ELSE
         ext_byte := 0

END; { procedure ViewBlockText.Control_Inf }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.Line_Down;

BEGIN
     IF ( NumberHelpBlock >= NumberEndBlock ) THEN
        EXIT;
     INC ( NumberHelpBlock );
     WHILE ( EndBlock [ NumberHelpBlock ] >=
             BeginBlock [ Number ] + Size_Y - 1 ) DO
           INC ( Number );
     IF ( Number > NumberEndBlock ) THEN
        FatalError ( ' 襭  Line_Down' )

END; { procedure ViewBlockText.Line_Down }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.Line_Up;

BEGIN
     IF ( NumberHelpBlock <= 1 ) THEN
        EXIT;
     DEC ( NumberHelpBlock );
     IF ( ( Number > 1 ) AND ( NumberHelpBlock < Number ) ) THEN
        DEC ( Number )

END; { procedure ViewBlockText.Line_Up }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.TextHome;

BEGIN
     Number := 1;
     NumberHelpBlock := 1

END; { procedure ViewBlockText.TextHome }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.TextEnd;

BEGIN
     Number := NumberEndBlock;
     NumberHelpBlock := Number

END; { procedure ViewBlockText.TextEnd }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.window_down;

VAR
   Index : BYTE;

BEGIN
     FOR Index := 1 TO WindowBlock DO
         Line_Down

END; { procedure ViewBlockText.wind_down }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.window_up;

VAR
   Index : BYTE;

BEGIN
     FOR Index := 1 TO WindowBlock DO
         Line_Up

END; { procedure ViewBlockText.window_up }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.Insert;

BEGIN
     IF ( ControlBlock [ NumberHelpBlock ] = 0 ) THEN
         ControlBlock [ NumberHelpBlock ] := 1
     ELSE
         ControlBlock [ NumberHelpBlock ] := 0

END; { procedure ViewBlockText.Insert }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.SetColorText ( Cl : BYTE );

          { ⠭ 梥 ⥪   }
BEGIN
     ColorText := Cl

END;  { procedure ViewBlockText.SetColorText }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.SetColorFon ( Cl : BYTE );

          { ⠭ 梥 䮭   }
BEGIN
     ColorFon := Cl

END;  { procedure ViewBlockText.SetColorFon }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.SetColorHelp ( Cl : BYTE );

          { ⠭ 梥 䮭 ⨢  }
BEGIN
     ColorHelp := Cl

END;  { procedure ViewBlockText.SetColorHelp }

{----------------------------------------------------------}

PROCEDURE ViewBlockText.SetColorInsert ( Cl : BYTE );

          { ⠭ 梥 ᨬ 뤥  }
BEGIN
     ColorInsert := Cl

END;  { procedure ViewBlockText.SetColorInsert }

{----------------------------------------------------------}

FUNCTION ViewBlockText.TestBlock ( num : LONGINT ) : BOOLEAN;

         { ஢ઠ     稥 }
         {            䫠 ⬥⪨            }
BEGIN
     IF ( ( Num < 1 ) OR ( Num > NumberEndBlock ) ) THEN
        FatalError ( ' ⠪    TestBlock' );
     TestBlock := ( ControlBlock [ Num ] <> 0 )

END; { function ViewBlockText.TestBlock }

{----------------------------------------------------------}

FUNCTION ViewBlockText.SizeBlock ( Num : LONGINT ) : LONGINT;

         { 뤠 ࠧ  / ⢮ ப / }
BEGIN
     IF ( ( Num < 1 ) OR ( Num > NumberEndBlock ) ) THEN
        FatalError ( ' ⠪    SizeBlock' );
     SizeBlock := EndBlock [ Num ] - BeginBlock [ Num ] + 1

END; { function ViewBlockText.SizeBlock  }

{----------------------------------------------------------}

DESTRUCTOR ViewBlockText.Done;

           { 樠 쥪 }
BEGIN
     ViewText.Done

END; { dectructor ViewBlockText.Done }

{----------------------------------------------------------}

DESTRUCTOR ViewBlockText.DoneWithStream;

           { 樠 쥪   ⮪ }
BEGIN
     ViewText.DoneWithStream

END; { dectructor ViewBlockText.DoneWithStream }

{==========================================================}

PROCEDURE ViewTehnicHelp.MarkBlock;

          { ન஢  }
VAR
   SingFirst : BOOLEAN;
   Line : STRING;
   Size : BYTE;

BEGIN
     NumberEndBlock := 1;
     TextStream^.SetLineNumber ( 1 );
     SingFirst := FALSE;
     Size := 0;
     WHILE ( ( NOT TextStream^.EOFText ) AND ( NumberEndBlock <= MaxBlk ) ) DO
           BEGIN
                TextStream^.ReadLine ( Line );
                IF ( NOT SingFirst ) THEN
                   BEGIN
                        IF ( ( LENGTH ( Line ) > 5 ) AND ( Line [ 1 ] = ' ' )
                             AND ( Line [ 2 ] IN [ '0','1','2','3','4','5',
                             '6','7','8','9' ] ) ) THEN
                           BEGIN
                                SingFirst := TRUE;
                                BeginBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 1;
                                Size := 0
                           END
                   END
                ELSE
                    BEGIN
                         INC ( Size );
                         IF ( ( LENGTH ( Line ) = 0 ) OR ( Line [ 1 ] = ' ' )
                             AND ( Line [ 2 ] IN [ '0','1','2','3','4','5',
                             '6','7','8','9' ] ) OR ( Line [ 1 ] <>   ' ' )
                             OR ( TextStream^.EOFText ) ) THEN
                            BEGIN
                                 EndBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 2;
                                 INC ( NumberEndBlock );
                                 BeginBlock [ NumberEndBlock ] :=
                                              TextStream^.GetLineNumber - 1;
                                 Size := 0;
                                 IF ( TextStream^.EOFText ) THEN
                                     DEC ( EndBlock [ NumberEndBlock - 1 ] )
                            END
                         ELSE
                             IF ( Size >= 10 ) THEN
                                BEGIN
                                     SingFirst  := FALSE;
                                     EndBlock [ NumberEndBlock ] :=
                                               TextStream^.GetLineNumber - 1;
                                     INC ( NumberEndBlock );
                                     Size := 0
                                END
                    END
           END;
     DEC ( NumberEndBlock );
     IF ( NumberEndBlock = 0 ) THEN
        FatalError ( '㦥   ⮪ MarkBlock' );
     TextStream^.SetLineNumber ( 1 )

END; { procedure ViewTehnicHelp.MarkBlock }

{----------------------------------------------------------}

FUNCTION ViewTehnicHelp.GetHelpNumber ( NumLine : LONGINT )
                : StandartString;

         {   ᪠ }
VAR
   Line : STRING;
   HelpS : StandartString;
   Hlp : BYTE;

BEGIN
     TextStream^.SetLineNumber ( NumLine );
     IF ( TextStream^.GetNumberError <> 0 ) THEN
        BEGIN
             GetHelpNumber := '';
             EXIT
        END;
     TextStream^.ReadLine ( Line );
     IF ( ( TextStream^.GetNumberError <> 0 ) OR
        ( LENGTH ( Line ) < 5 ) ) THEN
        BEGIN
             GetHelpNumber := '';
             EXIT
        END;
     WHILE ( ( Line [ 1 ] = ' ' ) AND ( Line <> '' ) ) DO
           DELETE ( Line, 1, 1 );
     Hlp := 1;
     HelpS := '';
     WHILE ( ( Line [ Hlp ] IN [ '1','2','3','4','5','6','7',
             '8','9','0','.' ] ) AND ( Hlp <= LENGTH ( Line ) ) ) DO
           BEGIN
                HelpS := HelpS + Line [ Hlp ];
                INC ( Hlp )
           END;
     GetHelpNumber := HelpS

END; { function ViewTehnicHelp.GetHelpNumber }

{----------------------------------------------------------}

PROCEDURE ViewTehnicHelp.Control_Inf ( VAR ext_byte : LONGINT );

         { 楤 ࠢ ଠ樥  }
         {        ⨢஢        }
VAR
   ChCmd : CHAR;
        {   }

   Line : String;
        { ப  ஬ 孮᪮ ᪠ }

   HelpS : StandartString;
        { ப  뤥 ஬ 孮᪮ ᪠ }

   IndexLine : BYTE;
        { ᭠ ६ }

   Err : INTEGER;
        {  訡 ८ࠧ ப }

BEGIN
     REPEAT
           show_inf;
           ChCmd := GetKeyBoard;
           IF ( GetSingKey ) THEN
              BEGIN
                   ChCmd := GetKeyBoard;
                   CASE ChCmd OF
                        arrow_down : line_down;
                        arrow_up   : line_up;
                        arrow_Left : CharLeft;
                        arrow_Right: CharRight;
                        page_down  : window_down;
                        page_up    : window_up;
                        key_ins    : Insert;
                        key_end    : TextEnd;
                        key_home   : TextHome
                   ELSE
                       run_for_key ( ChCmd );
                   END
              END
     UNTIL ( ChCmd IN [ #27, #$0D ] );
     IF ( ( ChCmd = #$0D ) OR ( ChCmd = #0 ) ) THEN
        ext_byte := BeginBlock [ NumberHelpBlock ]
     ELSE
         ext_byte := 0

END; { procedure ViewTehnicHelp.Control_Inf }

{----------------------------------------------------------}

END.